RegularExpression (Apache Ant API)
Description: declaration: package: org.apache.tools.ant.types, class: RegularExpression

# Class RegularExpression

java.lang.Object
org.apache.tools.ant.ProjectComponent
org.apache.tools.ant.types.DataType
org.apache.tools.ant.types.RegularExpression

All Implemented Interfaces:
  `Cloneable`

public class RegularExpression extends DataType
A regular expression datatype. Keeps an instance of the compiled expression for speed purposes. This compiled expression is lazily evaluated (it is compiled the first time it is needed). The syntax is the dependent on which regular expression type you are using. The system property "ant.regexp.regexpimpl" will be the classname of the implementation that will be used.

    Available implementations:

      org.apache.tools.ant.util.regexp.Jdk14RegexpRegexp (default)
           Based on the JDK's built-in regular expression package

      org.apache.tools.ant.util.regexp.JakartaOroRegexp
           Based on the jakarta-oro package

      org.apache.tools.ant.util.regexp.JakartaRegexpRegexp
           Based on the jakarta-regexp package

      <regexp [ [id="id"] pattern="expression" | refid="id" ]
      />

See Also:
  - `Perl5Compiler`
  - `RE`
  - `Pattern`
  - `Regexp`

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `DATA_TYPE_NAME`
  Name of this data type

  ### Fields inherited from class DataType

  `checked, ref`
  Modifier and Type
  Field
  Description
  `protected boolean`
  `checked`
  Deprecated.
  since 1.7.
  `protected Reference`
  `ref`
  Deprecated.
  since 1.7.

  ### Fields inherited from class ProjectComponent

  `description, location, project`
  Modifier and Type
  Field
  Description
  `protected String`
  `description`
  Deprecated.
  since 1.6.x.
  `protected Location`
  `location`
  Deprecated.
  since 1.6.x.
  `protected Project`
  `project`
  Deprecated.
  since 1.6.x.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `RegularExpression()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getPattern(Project p)`
  Gets the pattern string for this RegularExpression in the given project.
  `RegularExpression`
  `getRef(Project p)`
  Get the RegularExpression this reference refers to in the given project.
  `Regexp`
  `getRegexp(Project p)`
  provides a reference to the Regexp contained in this
  `void`
  `setPattern(String pattern)`
  sets the regular expression pattern

  ### Methods inherited from class DataType

  `checkAttributesAllowed, checkChildrenAllowed, circularReference, clone, dieOnCircularReference, dieOnCircularReference, dieOnCircularReference, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getDataTypeName, getRefid, invokeCircularReferenceCheck, isChecked, isReference, noChildrenAllowed, pushAndInvokeCircularReferenceCheck, setChecked, setRefid, tooManyAttributes, toString`
  Modifier and Type
  Method
  Description
  `protected void`
  `checkAttributesAllowed()`
  check that it is ok to set attributes, i.e that no reference is defined
  `protected void`
  `checkChildrenAllowed()`
  check that it is ok to add children, i.e that no reference is defined
  `protected BuildException`
  `circularReference()`
  Creates an exception that indicates the user has generated a loop of data types referencing each other.
  `Object`
  `clone()`
  `protected void`
  `dieOnCircularReference()`
  Convenience method.
  `protected void`
  `dieOnCircularReference(Stack<Object> stack, Project project)`
  Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).
  `protected void`
  `dieOnCircularReference(Project p)`
  Convenience method.
  `protected <T> T`
  `getCheckedRef()`
  Deprecated.
  use getCheckedRef(Class)
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Class<T> requiredClass, String dataTypeName, Project project)`
  Performs the check for circular references and returns the referenced object.
  `protected <T> T`
  `getCheckedRef(Project p)`
  Deprecated.
  use getCheckedRef(Class)
  `protected String`
  `getDataTypeName()`
  Gets as descriptive as possible a name used for this datatype instance.
  `Reference`
  `getRefid()`
  get the reference set on this object
  `static void`
  `invokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected boolean`
  `isChecked()`
  The flag that is used to indicate that circular references have been checked.
  `boolean`
  `isReference()`
  Has the refid attribute of this element been set?
  `protected BuildException`
  `noChildrenAllowed()`
  Creates an exception that indicates that this XML element must not have child elements if the refid attribute is set.
  `static void`
  `pushAndInvokeCircularReferenceCheck(DataType dt, Stack<Object> stk, Project p)`
  Allow DataTypes outside org.apache.tools.ant.types to indirectly call dieOnCircularReference on nested DataTypes.
  `protected void`
  `setChecked(boolean checked)`
  Set the flag that is used to indicate that circular references have been checked.
  `void`
  `setRefid(Reference ref)`
  Set the value of the refid attribute.
  `protected BuildException`
  `tooManyAttributes()`
  Creates an exception that indicates that refid has to be the only attribute if it is set.
  `String`
  `toString()`
  Basic DataType toString().

  ### Methods inherited from class ProjectComponent

  `getDescription, getLocation, getProject, log, log, setDescription, setLocation, setProject`
  Modifier and Type
  Method
  Description
  `String`
  `getDescription()`
  Returns the description of the current action.
  `Location`
  `getLocation()`
  Returns the file/location where this task was defined.
  `Project`
  `getProject()`
  Returns the project to which this component belongs.
  `void`
  `log(String msg)`
  Logs a message with the default (INFO) priority.
  `void`
  `log(String msg, int msgLevel)`
  Logs a message with the given priority.
  `void`
  `setDescription(String desc)`
  Sets a description of the current action.
  `void`
  `setLocation(Location location)`
  Sets the file/location where this task was defined.
  `void`
  `setProject(Project project)`
  Sets the project object of this component.

  ### Methods inherited from class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Field Details

  - ### DATA_TYPE_NAME

    public static final String DATA_TYPE_NAME
    Name of this data type
    See Also:
      - Constant Field Values

- ## Constructor Details

  - ### RegularExpression

    public RegularExpression()

- ## Method Details

  - ### setPattern

    public void setPattern(String pattern)
    sets the regular expression pattern
    Parameters:
      `pattern` - regular expression pattern

  - ### getPattern

    public String getPattern(Project p)
    Gets the pattern string for this RegularExpression in the given project.
    Parameters:
      `p` - project
    Returns:
      pattern

  - ### getRegexp

    public Regexp getRegexp(Project p)
    provides a reference to the Regexp contained in this
    Parameters:
      `p` - project
    Returns:
      Regexp instance associated with this RegularExpression instance

  - ### getRef

    public RegularExpression getRef(Project p)
    Get the RegularExpression this reference refers to in the given project. Check for circular references too
    Parameters:
      `p` - project
    Returns:
      resolved RegularExpression instance